src/core/prismriver/dashboard/urls.py
from django.conf.urls.defaults import *

urlpatterns = patterns('', url(r'^$', 'prismriver.dashboard.views.dashboard'))

src/e_cidadania/urls.py
# -*- coding: utf-8 -*-
#
# Copyright (c) 2013 Clione Software
# Copyright (c) 2010-2013 Cidadania S. Coop. Galega
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
Main URLs for the e-cidadania platform.
"""

from django.conf.urls import *
from django.conf import settings
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns

admin.autodiscover()

# We put here the dictionary with all the packages for translatin JavaScript code
# Please refer to https://docs.djangoproject.com/en/dev/topics/i18n/internationalization/#specifying-translation-strings-in-javascript-code
js_info_dict = {
    'packages': ('apps.ecidadania.debate',),
}

urlpatterns = patterns('',
    # i18n switcher
    (r'^i18n/', include('django.conf.urls.i18n')),
)

urlpatterns += patterns('',

    # Django administration
    (r'^admin/', include(admin.site.urls)),

    # Index
    url(r'^$', 'core.views.index.index_view', name='site-index'),

    # User accounts
    url(r'^accounts/', include('apps.thirdparty.userprofile.urls')),

    # REST API
    url(r'^api/', include('apps.ecidadania.api.urls')),

    # Spaces
    url(r'^spaces/', include('core.spaces.urls')),

    # Invitations
    url(r'^invite/', 'core.views.invite.invite', name='invite'),

    # Explore
    url(r'^explore/$', 'core.views.explore.explore', name='explore'),

    # This urls is for the django comments system
    url(r'^comments/', include('django.contrib.comments.urls')),

    (r'^jsi18n/$', 'django.views.i18n.javascript_catalog', js_info_dict),

    # For smart_selects app
    url(r'^chaining/', include('apps.thirdparty.smart_selects.urls')),

    # This url is for the access to static pages. I hope this doesn't collide
    # with the index view
    url(r'^(?P<slug>[\w\-]+)/', include('apps.ecidadania.staticpages.urls')),

)

if settings.DEBUG:
    # Serve static files
    urlpatterns += staticfiles_urlpatterns()
    # Serve uploaded files
    urlpatterns += patterns('',
        url(r'^uploads/(?P<path>.*)$', 'django.views.static.serve',
            {'document_root': settings.MEDIA_ROOT}),
    )

src/apps/thirdparty/userprofile/models.py
# coding=UTF-8
from django.db import models
from django.contrib.sites.models import Site
from django.contrib.auth.models import User
from django.template.defaultfilters import slugify
from django.utils.translation import ugettext as _
from django.template import loader, Context
from django.core.urlresolvers import reverse
from django.core.mail import send_mail
from django.conf import settings
import datetime
import cPickle as pickle
import base64
import Image
import ImageFilter
import os.path

AVATAR_SIZES = (128, 96, 64, 48, 32, 24, 16)


class BaseProfile(models.Model):
    """
    User profile model
    """

    user = models.ForeignKey(User, unique=True)
    date = models.DateTimeField(default=datetime.datetime.now)
    latitude = models.DecimalField(max_digits=10, decimal_places=6, blank=True, null=True)
    longitude = models.DecimalField(max_digits=10, decimal_places=6, blank=True, null=True)
    location = models.CharField(max_length=255, blank=True)

    class Meta:
        abstract = True

    def has_avatar(self):
        return Avatar.objects.filter(user=self.user, valid=True).count()

    def __unicode__(self):
        return _("%s's profile") % self.user

    def get_absolute_url(self):
        return reverse("profile_public", args=[self.user])


class Avatar(models.Model):
    """
    Avatar model
    """
    # image = models.ImageField(upload_to="avatars/%Y/%b/%d")
    image = models.ImageField(upload_to="avatars/")
    user = models.ForeignKey(User)
    date = models.DateTimeField(auto_now_add=True)
    valid = models.BooleanField()

    class Meta:
        unique_together = (('user', 'valid'),)

    def __unicode__(self):
        return _("%s's Avatar") % self.user

    def delete(self):
        base, filename = os.path.split(self.image.path)
        name, extension = os.path.splitext(filename)
        for key in AVATAR_SIZES:
            try:
                os.remove(os.path.join(base, "%s.%s%s" % (name, key, extension)))
            except:
                pass

        super(Avatar, self).delete()

    def save(self):
        for avatar in Avatar.objects.filter(user=self.user, valid=self.valid).exclude(id=self.id):
            base, filename = os.path.split(avatar.image.path)
            name, extension = os.path.splitext(filename)
            for key in AVATAR_SIZES:
                try:
                    os.remove(os.path.join(base, "%s.%s%s" % (name, key, extension)))
                except:
                    pass
            avatar.delete()

        super(Avatar, self).save()


class EmailValidationManager(models.Manager):
    """
    Email validation manager
    """
    def verify(self, key):
        try:
            verify = self.get(key=key)
            if not verify.is_expired():
                verify.user.email = verify.email
                verify.user.save()
                verify.delete()
                return True
            else:
                verify.delete()
                return False
        except:
            return False

    def getuser(self, key):
        try:
            return self.get(key=key).user
        except:
            return False

    def add(self, user, email):
        """
        Add a new validation process entry
        """
        while True:
            key = User.objects.make_random_password(70)
            try:
                EmailValidation.objects.get(key=key)
            except EmailValidation.DoesNotExist:
                self.key = key
                break

        template_body = "userprofile/email/validation.txt"
        template_subject = "userprofile/email/validation_subject.txt"
        site_name, domain = Site.objects.get_current().name, Site.objects.get_current().domain
        body = loader.get_template(template_body).render(Context(locals()))
        subject = loader.get_template(template_subject).render(Context(locals())).strip()
        send_mail(subject=subject, message=body, from_email=None, recipient_list=[email])
        user = User.objects.get(username=str(user))
        self.filter(user=user).delete()
        return self.create(user=user, key=key, email=email)


class EmailValidation(models.Model):
    """
    Email Validation model
    """
    user = models.ForeignKey(User, unique=True)
    email = models.EmailField(blank=True)
    key = models.CharField(max_length=70, unique=True, db_index=True)
    created = models.DateTimeField(auto_now_add=True)
    objects = EmailValidationManager()

    def __unicode__(self):
        return _("Email validation process for %(user)s") % {'user': self.user}

    def is_expired(self):
        return (datetime.datetime.today() - self.created).days > 0

    def resend(self):
        """
        Resend validation email
        """
        template_body = "userprofile/email/validation.txt"
        template_subject = "userprofile/email/validation_subject.txt"
        site_name, domain = Site.objects.get_current().name, Site.objects.get_current().domain
        key = self.key
        body = loader.get_template(template_body).render(Context(locals()))
        subject = loader.get_template(template_subject).render(Context(locals())).strip()
        send_mail(subject=subject, message=body, from_email=None, recipient_list=[self.email])
        self.created = datetime.datetime.now()
        self.save()
        return True

src/apps/thirdparty/userprofile/forms.py
from django import forms
from django.core.exceptions import ObjectDoesNotExist
from django.core.exceptions import ImproperlyConfigured
from django.core.validators import email_re
from django.db import models
from django.utils.translation import ugettext as _
from django.conf import settings
from django.contrib.auth.models import User
from apps.thirdparty.userprofile.models import EmailValidation
from django.core.files.uploadedfile import SimpleUploadedFile
import mimetypes
import urllib

if not settings.AUTH_PROFILE_MODULE:
    raise SiteProfileNotAvailable
try:
    app_label, model_name = settings.AUTH_PROFILE_MODULE.split('.')
    # app_label, model_name = settings.AUTH_PROFILE_MODULE.split('.')
    Profile = models.get_model(app_label, model_name)
except (ImportError, ImproperlyConfigured):
    raise SiteProfileNotAvailable


class LocationForm(forms.ModelForm):
    """
    Profile location form
    """

    class Meta:
        model = Profile
        fields = ('location', 'latitude', 'longitude', 'country', 'region',
                'city', 'district')


class ProfileForm(forms.ModelForm):
    """
    Profile Form. Composed by all the Profile model fields.
    """
    class Meta:
        model = Profile
        exclude = ('date', 'location', 'latitude', 'longitude', 'country',
                   'region', 'city', 'district', 'user', 'public')


class PublicFieldsForm(forms.ModelForm):
    """
    Public Fields of the Profile Form. Composed by all the Profile model fields.
    """
    class Meta:
        model = Profile
        exclude = ('date', 'user', 'public')


class AvatarForm(forms.Form):
    """
    The avatar form requires only one image field.
    """
    photo = forms.ImageField(required=False)
    url = forms.URLField(required=False)

    def clean_url(self):
        url = self.cleaned_data.get('url')
        if not url:
            return ''
        filename, headers = urllib.urlretrieve(url)
        if not mimetypes.guess_all_extensions(headers.get('Content-Type')):
            raise forms.ValidationError(_('The file type is invalid: %s' % type))
        return SimpleUploadedFile(filename, open(filename).read(), content_type=headers.get('Content-Type'))

    def clean(self):
        if not (self.cleaned_data.get('photo') or self.cleaned_data.get('url')):
            raise forms.ValidationError(_('You must enter one of the options'))
        return self.cleaned_data


class AvatarCropForm(forms.Form):
    """
    Crop dimensions form
    """
    top = forms.IntegerField()
    bottom = forms.IntegerField()
    left = forms.IntegerField()
    right = forms.IntegerField()

    def clean(self):
        if int(self.cleaned_data.get('right')) - int(self.cleaned_data.get('left')) < 96:
            raise forms.ValidationError(_("You must select a portion of the image with a minimum of 96x96 pixels."))
        else:
            return self.cleaned_data


class RegistrationForm(forms.Form):

    username = forms.CharField(max_length=255, min_length=3, label=_("Username"))
    email = forms.EmailField(required=True, label=_("E-mail address"))
    password1 = forms.CharField(widget=forms.PasswordInput,
        label=_("Password"))
    password2 = forms.CharField(widget=forms.PasswordInput,
        label=_("Password (again)"))

    def clean_email(self):
        """
        Verify that the email exists
        """
        email = self.cleaned_data['email']
        if not email:
            raise forms.ValidationError(_("E-mail address cannot be blank"))
        try:
                User.objects.get(email=email)
                raise forms.ValidationError(_("That e-mail is already used."))
        except User.DoesNotExist:
            try:
                EmailValidation.objects.get(email=email)
                raise forms.ValidationError(_("That e-mail is already being confirmed."))
            except EmailValidation.DoesNotExist:
                return email

    def clean_username(self):
        """
        Verify that the username isn't already registered
        """
        username = self.cleaned_data.get("username")
        if not set(username).issubset("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_."):
            raise forms.ValidationError(_("That username has invalid characters. The valid values are letters, numbers and underscore."))

        if User.objects.filter(username__iexact=username).count() == 0:
            return username
        else:
            raise forms.ValidationError(_("The username is already registered."))

    def clean(self):
        """
        Verify that the 2 passwords fields are equal
        """
        if self.cleaned_data.get("password1") == self.cleaned_data.get("password2"):
            return self.cleaned_data
        else:
            raise forms.ValidationError(_("The passwords inserted are different."))


class EmailValidationForm(forms.Form):
    email = forms.EmailField()

    def clean_email(self):
        """
        Verify that the email exists
        """
        email = self.cleaned_data.get("email")
        if not (User.objects.filter(email=email) or EmailValidation.objects.filter(email=email)):
            return email

        raise forms.ValidationError(_("That e-mail is already used."))


class ChangeEmail(EmailValidationForm):
    email2 = forms.EmailField(label=u'Type Email again')

src/apps/thirdparty/userprofile/templates/userprofile/avatar/choose.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans "Choose the location of your avatar" %}{% endblock %}
{% block robots %}noindex,nofollow{% endblock %}

<script type="text/javascript">
    $(function() {
    //avatar
        $("a.delavatar").click(function() {
            $.getJSON($(this).attr("href"), function(data) {
                if (data.success) {
                    $("img#avatarimg").attr("src", "/{{ generic96 }}");
                    $("p#avatardelete").remove();
                }
            });
            return false;
        });
    });
</script>

{% block content %}

    <div class="row">
        <legend>{% trans "Choose the location of your avatar" %}</legend>

        <form action="" method="post" accept-charset="utf-8" enctype="multipart/form-data">{% csrf_token %}
        {% if form.errors %}
            {% for error,desc in form.errors.items %}
                <p class="error">{{desc|join:"; "}}</p>
            {% endfor %}
        {% endif %}

        <fieldset>
            {% load avatars %}

            <div class="span2">
                <img class="border" id="avatarimg" src="{% avatar 96 %}" />
                {% if user.get_profile.has_avatar %}
                    <p id="avatardelete" style="text-align: center;">
                        <a href="{{ request.path_info }}delete/" class="delavatar">{% trans "Delete" %}</a>
                    </p>
                {% endif %}
            </div>

        <div class="span10">
            <ul class="unstyled">
                <li><label for="id_photo">{% trans "Select an image from disk" %}:</label>
                    <p>{{ form.photo }}
                        <input type="submit" value="{% trans 'Done' %}" />
                    </p>
                </li>
                
                <li><label for="id_url">{% trans "Select an image from a remote URL. Put the URL on the input below and we'll retrieve the image for you" %}:</label>
                    <p>{{ form.url }}
                        <input type="submit" value="{% trans 'Done' %}" />
                    </p>
                </li>
                
                {% if AVATAR_WEBSEARCH %}
                    <li>
                        <a class="large" href="{{ request.path_info }}search/">{% trans "Search for an image on Picasa Web" %}</a>
                    </li>
                {% endif %}
            </ul>
        </div>
    </div>

{% endblock %}

src/apps/thirdparty/userprofile/templates/userprofile/avatar/crop.html
{% extends "base.html" %}
{% load i18n %}
{% load static from staticfiles %}

{% block title %}{% trans "Crop &amp; resize the area you want" %}{% endblock %}
{% block robots %}noindex,nofollow{% endblock %}

{% block extrajs %}
<!--<script type="text/javascript" src="{{ MEDIA_URL }}js/jquery.imgareaselect-0.4.2.min.js"></script>-->
<!------Adding new image select js and css files ---------->
<link rel="stylesheet" type="text/css" href="{% static 'css/imgareaselect-default.css' %}" />
<script type="text/javascript" src="{% static 'js/jquery.imgareaselect.pack.js' %}"></script>
<script type="text/javascript">
    $(document).ready(function () {
      $('#cropimage').imgAreaSelect({
      onSelectEnd: function (img, selection) {
       $('input[name="left"]').val(selection.x1);
       $('input[name="top"]').val(selection.y1);
       $('input[name="right"]').val(selection.x2);
       $('input[name="bottom"]').val(selection.y2);            
         }
       });
     });
 </script>  
{% endblock %}

{% block nav-main %}
{% include "userprofile/menu.html" %}
{% endblock %}

{% block content %}
	<form action="{{ request.path_info }}" method="post" accept-charset="utf-8">
        {% csrf_token %}
	<fieldset>
		<legend>{% trans "Crop &amp; resize the area you want" %}</legend>

		{% if form.errors %}
			{% for error,desc in form.errors.items %}
				<p class="error">{{desc|join:"; "}}</p>
			{% endfor %}
		{% endif %}

		<div style="text-align: center;">
			<img src="{{ avatar.image.url }}" id="cropimage" />
		</div>
		<input type="hidden" name="top" value="0"/>
		<input type="hidden" name="bottom" value="0"/>
		<input type="hidden" name="left" value="0"/>
		<input type="hidden" name="right" value="0"/>
	</fieldset>
	<input type="submit" class="done" value="{% trans 'Done' %}" />
	</form>
{% endblock %}

{% block content-related %}
  <div class="box">
    <h3>{% trans "Avatar selection page" %}</h3>
    <p>{% trans "You have several options to select the image you want as avatar on your profile" %}.</p>
  </div>

  {% load avatars %}
  <div class="center">
    <img class="border" id="avatarimg" src="{% avatar 96 %}" />
  </div>

{% endblock %}

src/apps/thirdparty/userprofile/templates/userprofile/avatar/done.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans "Avatar selection finished" %}{% endblock %}
{% block robots %}noindex,nofollow{% endblock %}

{% block nav-main %}
{% include "userprofile/menu.html" %}
{% endblock %}

{% block content %}
	<p class="success large">
		{% trans "Your new avatar has been saved successfully" %}.
	</p>
  <hr>
  <a href="{% url 'profile_overview' %}" class="btn btn-danger btn-small">&laquo; {% trans "Go back" %}</a>
{% endblock %}

{% block content-related %}
  <div class="box">
    <h3>{% trans "Avatar selection page" %}</h3>
    <p>{% trans "You have several options to select the image you want as avatar on your profile" %}.</p>
  </div>

  {% load avatars %}
  <div class="center">
    <img class="border" id="avatarimg" src="{% avatar 96 %}" />
  </div>

{% endblock %}

src/apps/thirdparty/userprofile/templates/userprofile/avatar/search.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}{% trans "Search for an image on Picasa Web" %}{% endblock %}
{% block robots %}noindex,nofollow{% endblock %}

{% block extrajs %}
<script type="text/javascript">
	$(function() {
		$("input[type='text']").focus();
		$("input[type='text']").addClass("text");
		$("div.photos a").click(function() {
			$("form#avatar input[name='url']").val($(this).attr("href"));
			$("form#avatar").submit();
			return false;
		});
	});
</script>
{% endblock %}

{% block nav-main %}
{% include "userprofile/menu.html" %}
{% endblock %}

{% block content %}
	<form action="" method="post" accept-charset="utf-8">
	<fieldset>
		<legend>{% trans "Search for an image on Picasa Web" %}</legend>
		<label for="id_search">{% trans "Search on Picasa Web" %}</label>
		<p>
			<input type="text" name="keyword" value="{{ keyword }}" />
			<input type="submit" value="{% trans "Search" %}"/>
		</p>

		<div class="photos">
			{% for thumb,url in images.items %}
			<a href="{{ url }}"><img src="{{ thumb }}" /></a>
			{% endfor %}
		</div>
	</fieldset>
	</form>

	<form class="hide" id="avatar" action="{% url 'profile_edit_avatar' %}" method="post" accept-charset="utf-8">
		<input type="hidden" name="url" value="" />
	</form>
{% endblock %}

{% block content-related %}
  <div class="box">
    <h3>{% trans "Avatar selection page" %}</h3>
    <p>{% trans "You have several options to select the image you want as avatar on your profile" %}.</p>
  </div>

  {% load avatars %}
  <div class="center">
    <img class="border" id="avatarimg" src="{% avatar 96 %}" />
  </div>

{% endblock %}